// trees

function viewAllTrees_map(doc) {
    if (doc.type == "tree") {
        emit(doc.name, doc._id);
    }
}

function listTrees(head, req) {
    start({'headers': {'Content-Type': 'text/html; charset=utf-8'}});
    var count = head.total_rows;
    var word;
    if (count == 1) {
        word = 'strom';
    } else if (count >= 2 && count <= 4) {
        word = 'stromy';
    } else {
        word = 'strom\u016f';
    }
    send('<h1>' + count + ' ' + word + '</h1><div><ul>');
    var row;
    while (row = getRow()) {
        send('<li><a href=\"/cms-db/_design/trees/_show/tree/' + row.id + '\">' + row.key + '</a></li>');
    }
    send('</ul></div>');
}

function showTree(doc, req) {
    provides('html', function() {
        function renderTree(root) {
            var name;
            if (typeof(root.data) == 'string') {
                name = root.data;
            } else {
                name = root.data.title;
            }
            var html = '<ul><li>' + name + ' <a href=/cms-db/_design/docs/_list/docs/docs_in_trees?key=\"' + root.attributes.id + '\">-&gt;</a>';
            if (root.children) {
                for (var child in root.children) {
                    html += renderTree(root.children[child]);
                }
            }
            return html + '</li></ul>';
        }

        return '<h1>' + doc.name + '</h1><div>' + renderTree(doc.content) + '</div>';
    });
}

// docs

function viewAllDocs_map(doc) {
    if (doc.type == "doc") {
        emit(doc.name, doc);
    }
}

function viewDocsInTrees_map(doc) {
    if (doc.type == "doc" && doc.search_topics) {
        for (var topic in doc.search_topics) {
            emit(doc.search_topics[topic], doc);
        }
    }
}

function listDocs(head, req) {
    start({'headers': {'Content-Type': 'text/html; charset=utf-8'}});
    send('<div><ul>');
    var row;
    while (row = getRow()) {
        send('<li><a href=\"/cms-db/_design/docs/_show/doc/' + row.id + '\">' + row.value.name + '</a></li>');
    }
    send('</ul></div>');
}

function showDoc(doc, req) {
    provides('html', function() {
        return '<h1>' + doc.name + '</h1><div>' + doc.desc + '</div><hr><p>Autor: <em>' + doc.author + '</em></p>';
    });
}

function showDoc_l10n(doc, req) {
    var lang = req.query.lang;
    if (lang) {
        for (var attr in doc) {
          if (doc[attr + '_' + lang]) {
            doc[attr] = doc[attr + '_' + lang];
          } else if (attr.match('_' + lang + '$')) { // attr.endsWith('_' + lang)
            // neni nutne, ale pro renderovani proste chci mit v dokumentu jen "kanonicke" atributy
            doc[attr] = null;
          }
      }
    }

    provides('html', function() {
        return '<h1>' + doc.name + '</h1><div>' + doc.desc + '</div><hr><p>Autor: <em>' + doc.author + '</em></p>';
    });
}

function validateDocUpdate(newDoc, oldDoc, userCtx) {
    if (newDoc._deleted) {
        return;
    }
    if (!newDoc.name) {
        throw({forbidden: 'Must have a name!'});
    }
}
