(function($) {
    // needs: tiny_mce.js, jquery.tinymce.js
    $.fn.initMce = function(data) {
        var _this = this;
        $(this).tinymce({
            theme: "simple", // advanced
            theme_advanced_toolbar_location: "top",
            theme_advanced_toolbar_align: "left",
            theme_advanced_statusbar_location: "bottom",
            theme_advanced_resizing: true,
            setup: function(ed) {
                ed.onInit.add(function() {
                    _this.html(data);
                });
            }
        });
        return this;
    };

    // needs: jquery.tree.js, jquery.couch.js
    $.fn.myTree = function(data) {
        $(this).tree({
            ui: { theme_name: "classic" },
            data: {
                type: "json",
                opts: { static: data }
            },
            plugins: { contextmenu: {} },
            callback: {
                beforecreate: function(node, refNode, type, treeObj) {
                    $(node).attr("id", $.couch.newUUID());
                    return true;
                }
            }
        });
        return this;
    };
    $.fn.checkboxTree = function(data) {
        $(this).tree({
            ui: { theme_name: "checkbox" },
            data: {
                type: "json",
                opts: { static: data }
            },
            plugins: { checkbox: {} }
        });
        return this;
    };

    // needs: jquery.jgrowl.js
    $.extend($.jGrowl.defaults, {
        life: 5000,
        closer: false
    });
})(jQuery);
