import groovyx.net.http.RESTClient
import org.apache.http.entity.FileEntity
import static groovyx.net.http.ContentType.JSON

class HttpClient {
    final RESTClient http

    def HttpClient(defaultUri) {
        http = new RESTClient(defaultUri)
        // posilana data vzdy kodovat jako utf-8
        http.encoder.charset = 'utf-8'
        // CouchDB posila data defaultne jako text/plain (kvuli prohlizecum), i kdyz je to vzdy
        // JSON, a kdyz si o application/json explicitne reknu, tak zase nadava HTTP Builder,
        // ze Content-Type neobsahuje charset
        http.parser.'text/plain' = http.parser.'application/json'
        // defaultni failure zavola success a vyhodi vyjimku -- jenze o tu tady nestojim
        http.handler.failure = http.handler.success
        // kdyz budu posilat data (POST, PUT), bude to vzdy JSON (tak at to nemusim porad rikat)
        http.defaultRequestContentType = JSON
        // HTTP Builder zna jen nekolik MIME typu, takze kvuli prikladani priloh musim kodery
        // pro konkretni MIME typy nadefinovat explicitne
        //
        // pozor: pocitam s tim, ze uzivatel jako posilana data vzdy doda objekt File!
        // InputStream by taky fungoval, jenze HTTP Core zvoli Transfer-Encoding: chunked
        // (protoze predem nezna velikost) a nginx chunked nepodporuje a vraci 411 :-(
        setFileEncoderFor 'image/jpeg'
    }

    def setFileEncoderFor(contentType) {
        http.encoder[contentType] = { data -> new FileEntity(data, contentType) }
    }

    def Object get(Map<String, ?> args) {
        return http.get(args)
    }

    def Object post(Map<String, ?> args) {
        return http.post(args)
    }

    def Object put(Map<String, ?> args) {
        return http.put(args)
    }

    def Object head(Map<String, ?> args) {
        return http.head(args)
    }

    def Object delete(Map<String, ?> args) {
        return http.delete(args)
    }

    def Object options(Map<String, ?> args) {
        return http.options(args)
    }
}
