def http = new HttpClient('http://localhost:5984/')
def dbName = 'pokus'

def createDoc = { doc ->
    def resp = http.post(path: "/${dbName}", body: doc)
    println "Create document: status = ${resp.status}, data = ${resp.data}"
    return [resp.data.id, resp.data.rev]
}

def getDoc = { id ->
    resp = http.get(path: "/${dbName}/${id}")
    println "Get document: status = ${resp.status}, data = ${resp.data}"
    return resp.data
}

def updateDoc = { doc ->
    resp = http.put(path: "/${dbName}/${doc._id}", body: doc)
    println "Update document: status = ${resp.status}, data = ${resp.data}"
    return [resp.data.id, resp.data.rev]
}

def deleteDoc = { id, rev ->
    resp = http.delete(path: "/${dbName}/${id}", query: ['rev': rev])
    println "Delete document: status = ${resp.status}, data = ${resp.data}"
}

def doc = ['name': 'Ládíček', 'age': 'se neříká']
def id, rev

(id, rev) = createDoc(doc)

doc = getDoc(id)

doc.langs = ['java', 'groovy']
doc.truths = ['java': 'mrtvola',
        'groovy': 'vcelku slušný kompromis',
        'scala': 'akademická splácanina',
        'javascript': 'lisp pro normální lidi',
        'sql': 'sucks']
doc.seznamMap = [['a': 1, 'b': 2], ['c': 3, 'd': 4], ['ef': [5, 6], 'gh': ['i': 'j', 'k': 'l']]]

(id, rev) = updateDoc(doc)

//deleteDoc(id, rev)
