def http = new HttpClient('http://localhost:5984/')
def dbName = 'pokus'

def getDoc = { id ->
    resp = http.get(path: "/${dbName}/${id}")
    println "Get document: status = ${resp.status}, data = ${resp.data}"
    return resp.data
}

def attach = { doc, filePath, contentType ->
    def file = new File(filePath)
    resp = http.put(
            path: "/${dbName}/${doc._id}/${file.name}",
            query: ['rev': doc._rev],
            requestContentType: contentType,
            body: file)
    println "Attach: status = ${resp.status}, data = ${resp.data}"
    return [resp.data.id, resp.data.rev]
}

def resp = http.get(path: "/${dbName}/_all_docs")
println "Get all docs: status = ${resp.status}, data = ${resp.data}"
def row = resp.data.rows[0]
def doc = getDoc(row.id)

attach(doc, '/home/ladicek/normal_phoenix-firebird-firefox-firecat.jpg', 'image/jpeg')
